<?php // lib/protector.php

/* New file, created 2004-10-13 by Jesper to battle something called "XSS".
   If you use <img src="javascript:alert('foo')">, IE will actually show the
   dialog box as specified. Some more training and you'll be stealing passwords
   and cookies. So we need to filter a lot of stuff for this. There will be
   a few functions to filter most of the output (posts or even stuff like 
   minipics) here. */
   
/* All calls to any function in this file should be ended with a comment of
   this: v--------v 
          // @XSS@
         ^--------^
   on every line.
*/

function sanitize_url($url) {
	$url = preg_replace("'[ \t\n]'", "", $url); // first, remove whitespace
    if (preg_match("'^.+?%[0-9]{2}.+?:'", $url)) { 
    // we have a percentage sign and two numbers before the first colon. 
    // this could be a protocol (such as javascript:) with the protocol url encoded.
      $url = urldecode($url);
    }
    if (preg_match("'^javascript:'i", $url)) {
      $url = "";
    }
    return $url;
}

function sanitize_html($html) {
    $html = preg_replace("'\b\s*(href|src)(\s*)?(=)(\s*)?((\'|\"))?(.*?)(\\6|)(\s|>)'ie", "(sanitize_url('\\7')!=''?'\\1\\2\\3\\4'.sanitize_url('\\7').'\\8\\9':'')", $html);
    $html = preg_replace("'\b\s*(on([a-z]*))(\s*)?(=)(\s*)?((\'|\"))?(.*?)(\\7|)(\s|>)'i", "\\10", $html);
//    \s*(on([a-z]*))(\s*)?(=)((\s*)?('|")|)(.*?)(\5|)(\s|>)
    $html = preg_replace("'<script(.*?)</script>'i", "", $html);
    return $html;
}

?>